submodule: add --progress option to add command
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
f6a52799 11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
abed000a 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
c32eaa8a
SB
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
8f321a39 17OPTIONS_SPEC=
091a6eb0 18SUBDIRECTORY_OK=Yes
70c7ac22 19. git-sh-setup
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
f1762d77
BW
25# Tell the rest of git that any URLs we get don't come
26# directly from the user, so it can apply policy as appropriate.
27GIT_PROTOCOL_FROM_USER=0
28export GIT_PROTOCOL_FROM_USER
33cfccbb 29
5c08dbbd 30command=
ecda0723 31branch=
d27b876b 32force=
d92a3959 33reference=
70c7ac22 34cached=
48bb3033
GP
35recursive=
36init=
1c244f6e 37files=
06b1abb5 38remote=
31ca3ac3 39nofetch=
32948425 40update=
15fc56a8 41prefix=
73b0898d 42custom_name=
275cd184 43depth=
72c5f883 44progress=
70c7ac22 45
be9d0a3a
HV
46die_if_unmatched ()
47{
48 if test "$1" = "#unmatched"
49 then
c4c02bf1 50 exit ${2:-1}
be9d0a3a
HV
51 fi
52}
53
88ce00c3
TK
54#
55# Print a submodule configuration setting
56#
57# $1 = submodule name
58# $2 = option name
59# $3 = default value
60#
61# Checks in the usual git-config places first (for overrides),
62# otherwise it falls back on .gitmodules. This allows you to
63# distribute project-wide defaults in .gitmodules, while still
64# customizing individual repositories if necessary. If the option is
65# not in .gitmodules either, print a default value.
66#
67get_submodule_config () {
68 name="$1"
69 option="$2"
70 default="$3"
71 value=$(git config submodule."$name"."$option")
72 if test -z "$value"
73 then
74 value=$(git config -f .gitmodules submodule."$name"."$option")
75 fi
76 printf '%s' "${value:-$default}"
77}
78
862ae6cd
RS
79isnumber()
80{
81 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
82}
83
14111fc4
JK
84# Sanitize the local git environment for use within a submodule. We
85# can't simply use clear_local_git_env since we want to preserve some
86# of the settings from GIT_CONFIG_PARAMETERS.
87sanitize_submodule_env()
88{
89044baa 89 save_config=$GIT_CONFIG_PARAMETERS
14111fc4 90 clear_local_git_env
89044baa 91 GIT_CONFIG_PARAMETERS=$save_config
860cba61 92 export GIT_CONFIG_PARAMETERS
14111fc4
JK
93}
94
ecda0723
SV
95#
96# Add a new submodule to the working tree, .gitmodules and the index
97#
ec05df35 98# $@ = repo path
ecda0723
SV
99#
100# optional branch is stored in global branch variable
101#
23a485e3 102cmd_add()
ecda0723 103{
5c08dbbd 104 # parse $args after "submodule ... add".
091a6eb0 105 reference_path=
5c08dbbd
JH
106 while test $# -ne 0
107 do
108 case "$1" in
109 -b | --branch)
110 case "$2" in '') usage ;; esac
111 branch=$2
112 shift
113 ;;
d27b876b
JL
114 -f | --force)
115 force=$1
116 ;;
5c08dbbd 117 -q|--quiet)
2e6a30ef 118 GIT_QUIET=1
5c08dbbd 119 ;;
6d33e1c2
CF
120 --progress)
121 progress=1
122 ;;
d92a3959
MT
123 --reference)
124 case "$2" in '') usage ;; esac
091a6eb0 125 reference_path=$2
d92a3959
MT
126 shift
127 ;;
128 --reference=*)
091a6eb0 129 reference_path="${1#--reference=}"
d92a3959 130 ;;
73b0898d
JL
131 --name)
132 case "$2" in '') usage ;; esac
133 custom_name=$2
134 shift
135 ;;
275cd184
FG
136 --depth)
137 case "$2" in '') usage ;; esac
138 depth="--depth=$2"
139 shift
140 ;;
141 --depth=*)
142 depth=$1
143 ;;
5c08dbbd
JH
144 --)
145 shift
146 break
147 ;;
148 -*)
149 usage
150 ;;
151 *)
152 break
153 ;;
154 esac
155 shift
156 done
157
091a6eb0
JK
158 if test -n "$reference_path"
159 then
160 is_absolute_path "$reference_path" ||
161 reference_path="$wt_prefix$reference_path"
162
163 reference="--reference=$reference_path"
164 fi
165
ecda0723 166 repo=$1
64394e3a 167 sm_path=$2
ecda0723 168
64394e3a 169 if test -z "$sm_path"; then
6a066230 170 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
171 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
172 fi
173
496eeeb1 174 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
175 usage
176 fi
177
091a6eb0
JK
178 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
179
ec05df35
ML
180 # assure repo is absolute or relative to parent
181 case "$repo" in
182 ./*|../*)
091a6eb0
JK
183 test -z "$wt_prefix" ||
184 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
185
ec05df35 186 # dereference source url relative to parent's url
63e95beb 187 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
ec05df35
ML
188 ;;
189 *:*|/*)
190 # absolute url
191 realrepo=$repo
192 ;;
193 *)
497ee872 194 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
195 ;;
196 esac
197
db75ada5
MG
198 # normalize path:
199 # multiple //; leading ./; /./; /../; trailing /
64394e3a 200 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
201 sed -e '
202 s|//*|/|g
203 s|^\(\./\)*||
8196e728 204 s|/\(\./\)*|/|g
db75ada5
MG
205 :start
206 s|\([^/]*\)/\.\./||
207 tstart
208 s|/*$||
209 ')
619acfc7
SB
210 if test -z "$force"
211 then
212 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
213 die "$(eval_gettext "'\$sm_path' already exists in the index")"
214 else
215 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
216 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
217 fi
ecda0723 218
53213994
JK
219 if test -z "$force" &&
220 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
d27b876b 221 then
6ff875c5 222 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 223\$sm_path
6ff875c5 224Use -f if you really want to add it." >&2
d27b876b
JL
225 exit 1
226 fi
227
73b0898d
JL
228 if test -n "$custom_name"
229 then
230 sm_name="$custom_name"
231 else
232 sm_name="$sm_path"
233 fi
234
d4264ca3 235 # perhaps the path exists and is already a git repo, else clone it
64394e3a 236 if test -e "$sm_path"
d4264ca3 237 then
496eeeb1 238 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 239 then
64394e3a 240 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 241 else
64394e3a 242 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 243 fi
c2f93917 244
d4264ca3 245 else
4b7c286e
JL
246 if test -d ".git/modules/$sm_name"
247 then
248 if test -z "$force"
249 then
0d71dbfd 250 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
4b7c286e 251 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
0d71dbfd
VA
252 die "$(eval_gettextln "\
253If you want to reuse this local git directory instead of cloning again from
254 \$realrepo
255use the '--force' option. If the local git directory is not the correct repo
256or you are unsure what this means choose another name with the '--name' option.")"
4b7c286e 257 else
0d71dbfd 258 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
4b7c286e
JL
259 fi
260 fi
6d33e1c2 261 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
d851ffb9 262 (
14111fc4 263 sanitize_submodule_env
d851ffb9
JH
264 cd "$sm_path" &&
265 # ash fails to wordsplit ${branch:+-b "$branch"...}
266 case "$branch" in
267 '') git checkout -f -q ;;
268 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
269 esac
270 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 271 fi
73b0898d 272 git config submodule."$sm_name".url "$realrepo"
d4264ca3 273
53213994 274 git add --no-warn-embedded-repo $force "$sm_path" ||
64394e3a 275 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 276
73b0898d
JL
277 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
278 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
279 if test -n "$branch"
280 then
281 git config -f .gitmodules submodule."$sm_name".branch "$branch"
282 fi &&
31991b02 283 git add --force .gitmodules ||
64394e3a 284 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
1b614c07
BW
285
286 # NEEDSWORK: In a multi-working-tree world, this needs to be
287 # set in the per-worktree config.
288 if git config --get submodule.active >/dev/null
289 then
290 # If the submodule being adding isn't already covered by the
291 # current configured pathspec, set the submodule's active flag
292 if ! git submodule--helper is-active "$sm_path"
293 then
294 git config submodule."$sm_name".active "true"
295 fi
296 else
297 git config submodule."$sm_name".active "true"
298 fi
ecda0723
SV
299}
300
19a31f9c
ML
301#
302# Execute an arbitrary command sequence in each checked out
303# submodule
304#
305# $@ = command to execute
306#
307cmd_foreach()
308{
1d5bec8b
JH
309 # parse $args after "submodule ... foreach".
310 while test $# -ne 0
311 do
312 case "$1" in
313 -q|--quiet)
314 GIT_QUIET=1
315 ;;
15fc56a8
JH
316 --recursive)
317 recursive=1
318 ;;
1d5bec8b
JH
319 -*)
320 usage
321 ;;
322 *)
323 break
324 ;;
325 esac
326 shift
327 done
328
f030c96d
ÆAB
329 toplevel=$(pwd)
330
4dca1aa6
BC
331 # dup stdin so that it can be restored when running the external
332 # command in the subshell (and a recursive call to this function)
333 exec 3<&0
334
b0f4b408
SB
335 {
336 git submodule--helper list --prefix "$wt_prefix" ||
c4c02bf1 337 echo "#unmatched" $?
b0f4b408 338 } |
cf9e55f4 339 while read -r mode sha1 stage sm_path
19a31f9c 340 do
c4c02bf1 341 die_if_unmatched "$mode" "$sha1"
64394e3a 342 if test -e "$sm_path"/.git
19a31f9c 343 then
44431df0 344 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
ea2fa104 345 say "$(eval_gettext "Entering '\$displaypath'")"
0ea306ef 346 name=$(git submodule--helper name "$sm_path")
15fc56a8 347 (
64394e3a 348 prefix="$prefix$sm_path/"
14111fc4 349 sanitize_submodule_env
64394e3a 350 cd "$sm_path" &&
44431df0 351 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
091a6eb0
JK
352 # we make $path available to scripts ...
353 path=$sm_path &&
1c4fb136
AK
354 if test $# -eq 1
355 then
356 eval "$1"
357 else
358 "$@"
359 fi &&
15fc56a8
JH
360 if test -n "$recursive"
361 then
362 cmd_foreach "--recursive" "$@"
363 fi
4dca1aa6 364 ) <&3 3<&- ||
ea2fa104 365 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
19a31f9c
ML
366 fi
367 done
368}
369
70c7ac22 370#
211b7f19 371# Register submodules in .git/config
70c7ac22
LH
372#
373# $@ = requested paths (default to all)
374#
23a485e3 375cmd_init()
70c7ac22 376{
5c08dbbd
JH
377 # parse $args after "submodule ... init".
378 while test $# -ne 0
379 do
380 case "$1" in
381 -q|--quiet)
2e6a30ef 382 GIT_QUIET=1
5c08dbbd
JH
383 ;;
384 --)
385 shift
386 break
387 ;;
388 -*)
389 usage
390 ;;
391 *)
392 break
393 ;;
394 esac
395 shift
396 done
397
6e7c14e6 398 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
70c7ac22
LH
399}
400
cf419828
JL
401#
402# Unregister submodules from .git/config and remove their work tree
403#
cf419828
JL
404cmd_deinit()
405{
406 # parse $args after "submodule ... deinit".
f6a52799 407 deinit_all=
cf419828
JL
408 while test $# -ne 0
409 do
410 case "$1" in
411 -f|--force)
412 force=$1
413 ;;
414 -q|--quiet)
415 GIT_QUIET=1
416 ;;
f6a52799
SB
417 --all)
418 deinit_all=t
419 ;;
cf419828
JL
420 --)
421 shift
422 break
423 ;;
424 -*)
425 usage
426 ;;
427 *)
428 break
429 ;;
430 esac
431 shift
432 done
433
2e612731 434 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} "$@"
cf419828
JL
435}
436
fb43e31f 437is_tip_reachable () (
01e1d544 438 sanitize_submodule_env &&
fb43e31f
SB
439 cd "$1" &&
440 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
441 test -z "$rev"
442)
443
444fetch_in_submodule () (
01e1d544 445 sanitize_submodule_env &&
fb43e31f
SB
446 cd "$1" &&
447 case "$2" in
448 '')
449 git fetch ;;
450 *)
6cbf454a
SB
451 shift
452 git fetch $(get_default_remote) "$@" ;;
fb43e31f
SB
453 esac
454)
455
70c7ac22 456#
211b7f19 457# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
458#
459# $@ = requested paths (default to all)
460#
23a485e3 461cmd_update()
70c7ac22 462{
5c08dbbd
JH
463 # parse $args after "submodule ... update".
464 while test $# -ne 0
465 do
466 case "$1" in
467 -q|--quiet)
2e6a30ef 468 GIT_QUIET=1
5c08dbbd 469 ;;
72c5f883 470 --progress)
c7199e3a 471 progress=1
72c5f883 472 ;;
be4d2c83 473 -i|--init)
d92a3959 474 init=1
be4d2c83 475 ;;
06b1abb5
TK
476 --remote)
477 remote=1
478 ;;
31ca3ac3 479 -N|--no-fetch)
31ca3ac3
FF
480 nofetch=1
481 ;;
9db31bdf
NMC
482 -f|--force)
483 force=$1
484 ;;
ca2cedba 485 -r|--rebase)
32948425 486 update="rebase"
ca2cedba 487 ;;
d92a3959
MT
488 --reference)
489 case "$2" in '') usage ;; esac
490 reference="--reference=$2"
98dbe63d 491 shift
d92a3959
MT
492 ;;
493 --reference=*)
494 reference="$1"
d92a3959 495 ;;
42b49178 496 -m|--merge)
42b49178
JH
497 update="merge"
498 ;;
b13fd5c1 499 --recursive)
b13fd5c1
JH
500 recursive=1
501 ;;
efc5fb6a
JH
502 --checkout)
503 update="checkout"
504 ;;
abed000a
SB
505 --recommend-shallow)
506 recommend_shallow="--recommend-shallow"
507 ;;
508 --no-recommend-shallow)
509 recommend_shallow="--no-recommend-shallow"
510 ;;
275cd184
FG
511 --depth)
512 case "$2" in '') usage ;; esac
513 depth="--depth=$2"
514 shift
515 ;;
516 --depth=*)
517 depth=$1
518 ;;
2335b870
SB
519 -j|--jobs)
520 case "$2" in '') usage ;; esac
521 jobs="--jobs=$2"
522 shift
523 ;;
524 --jobs=*)
525 jobs=$1
526 ;;
5c08dbbd
JH
527 --)
528 shift
529 break
530 ;;
531 -*)
532 usage
533 ;;
534 *)
535 break
536 ;;
537 esac
98dbe63d 538 shift
5c08dbbd
JH
539 done
540
d92a3959
MT
541 if test -n "$init"
542 then
543 cmd_init "--" "$@" || return
544 fi
545
48308681
SB
546 {
547 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
c7199e3a 548 ${progress:+"--progress"} \
48308681
SB
549 ${wt_prefix:+--prefix "$wt_prefix"} \
550 ${prefix:+--recursive-prefix "$prefix"} \
551 ${update:+--update "$update"} \
5f50f33e 552 ${reference:+"$reference"} \
48308681 553 ${depth:+--depth "$depth"} \
c7199e3a
CF
554 $recommend_shallow \
555 $jobs \
c4c02bf1 556 "$@" || echo "#unmatched" $?
48308681 557 } | {
15ffb7cd 558 err=
cf9e55f4 559 while read -r mode sha1 stage just_cloned sm_path
70c7ac22 560 do
c4c02bf1 561 die_if_unmatched "$mode" "$sha1"
48308681 562
0ea306ef 563 name=$(git submodule--helper name "$sm_path") || exit
efc5fb6a
JH
564 if ! test -z "$update"
565 then
566 update_module=$update
567 else
568 update_module=$(git config submodule."$name".update)
a2aed08b
TK
569 if test -z "$update_module"
570 then
571 update_module="checkout"
572 fi
efc5fb6a
JH
573 fi
574
44431df0 575 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
091a6eb0 576
48308681 577 if test $just_cloned -eq 1
d851ffb9 578 then
bf2d8246 579 subsha1=
e7b37caf
SB
580 case "$update_module" in
581 merge | rebase | none)
582 update_module=checkout ;;
583 esac
bf2d8246 584 else
14111fc4 585 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 586 git rev-parse --verify HEAD) ||
091a6eb0 587 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 588 fi
211b7f19 589
06b1abb5
TK
590 if test -n "$remote"
591 then
92bbe7cc 592 branch=$(git submodule--helper remote-branch "$sm_path")
06b1abb5
TK
593 if test -z "$nofetch"
594 then
595 # Fetch remote before determining tracking $sha1
6cbf454a 596 fetch_in_submodule "$sm_path" $depth ||
06b1abb5
TK
597 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
598 fi
14111fc4
JK
599 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
600 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5 601 git rev-parse --verify "${remote_name}/${branch}") ||
c87302bf 602 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
06b1abb5
TK
603 fi
604
496eeeb1 605 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 606 then
9db31bdf
NMC
607 subforce=$force
608 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 609 if test -z "$subsha1" && test -z "$force"
b9b378a0 610 then
9db31bdf 611 subforce="-f"
b9b378a0 612 fi
31ca3ac3
FF
613
614 if test -z "$nofetch"
615 then
e5f522d6
JL
616 # Run fetch only if $sha1 isn't present or it
617 # is not reachable from a ref.
fb43e31f 618 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 619 fetch_in_submodule "$sm_path" $depth ||
091a6eb0 620 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
fb43e31f
SB
621
622 # Now we tried the usual fetch, but $sha1 may
623 # not be reachable from any of the refs
624 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 625 fetch_in_submodule "$sm_path" $depth "$sha1" ||
c87302bf 626 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
31ca3ac3
FF
627 fi
628
877449c1 629 must_die_on_failure=
32948425 630 case "$update_module" in
a2aed08b
TK
631 checkout)
632 command="git checkout $subforce -q"
633 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
634 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
635 ;;
32948425
JH
636 rebase)
637 command="git rebase"
091a6eb0
JK
638 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
639 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 640 must_die_on_failure=yes
32948425 641 ;;
42b49178
JH
642 merge)
643 command="git merge"
091a6eb0
JK
644 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
645 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 646 must_die_on_failure=yes
42b49178 647 ;;
6cb5728c
CP
648 !*)
649 command="${update_module#!}"
b08238ac
SB
650 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
651 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
6cb5728c
CP
652 must_die_on_failure=yes
653 ;;
32948425 654 *)
a2aed08b 655 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
32948425 656 esac
70c7ac22 657
14111fc4 658 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 659 then
ff968f03 660 say "$say_msg"
877449c1
JH
661 elif test -n "$must_die_on_failure"
662 then
ff968f03 663 die_with_status 2 "$die_msg"
15ffb7cd 664 else
ff968f03 665 err="${err};$die_msg"
877449c1 666 continue
15ffb7cd 667 fi
70c7ac22 668 fi
b13fd5c1
JH
669
670 if test -n "$recursive"
671 then
75bf5e60 672 (
44431df0 673 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
3604242f 674 wt_prefix=
14111fc4 675 sanitize_submodule_env
75bf5e60 676 cd "$sm_path" &&
36141282 677 eval cmd_update
75bf5e60 678 )
15ffb7cd
FG
679 res=$?
680 if test $res -gt 0
681 then
091a6eb0 682 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
bb9d91b4 683 if test $res -ne 2
15ffb7cd 684 then
ff968f03 685 err="${err};$die_msg"
15ffb7cd
FG
686 continue
687 else
ff968f03 688 die_with_status $res "$die_msg"
15ffb7cd
FG
689 fi
690 fi
b13fd5c1 691 fi
70c7ac22 692 done
15ffb7cd
FG
693
694 if test -n "$err"
695 then
696 OIFS=$IFS
697 IFS=';'
698 for e in $err
699 do
700 if test -n "$e"
701 then
702 echo >&2 "$e"
703 fi
704 done
705 IFS=$OIFS
706 exit 1
707 fi
708 }
70c7ac22
LH
709}
710
28f9af5d
PY
711#
712# Show commit summary for submodules in index or working tree
713#
714# If '--cached' is given, show summary between index and given commit,
715# or between working tree and given commit
716#
717# $@ = [commit (default 'HEAD'),] requested paths (default all)
718#
719cmd_summary() {
f2dc06a3 720 summary_limit=-1
d0f64dd4 721 for_status=
1c244f6e 722 diff_cmd=diff-index
f2dc06a3 723
28f9af5d
PY
724 # parse $args after "submodule ... summary".
725 while test $# -ne 0
726 do
727 case "$1" in
728 --cached)
729 cached="$1"
730 ;;
1c244f6e
JL
731 --files)
732 files="$1"
733 ;;
d0f64dd4
PY
734 --for-status)
735 for_status="$1"
736 ;;
f2dc06a3 737 -n|--summary-limit)
862ae6cd
RS
738 summary_limit="$2"
739 isnumber "$summary_limit" || usage
f2dc06a3
PY
740 shift
741 ;;
862ae6cd
RS
742 --summary-limit=*)
743 summary_limit="${1#--summary-limit=}"
744 isnumber "$summary_limit" || usage
745 ;;
28f9af5d
PY
746 --)
747 shift
748 break
749 ;;
750 -*)
751 usage
752 ;;
753 *)
754 break
755 ;;
756 esac
757 shift
758 done
bffe71f4 759
f2dc06a3
PY
760 test $summary_limit = 0 && return
761
3deea89c 762 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
763 then
764 head=$rev
caa9c3ca 765 test $# = 0 || shift
496eeeb1 766 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 767 then
14e940d7
JH
768 # before the first commit: compare with an empty tree
769 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 770 test -z "$1" || shift
28f9af5d 771 else
3deea89c 772 head="HEAD"
28f9af5d
PY
773 fi
774
1c244f6e
JL
775 if [ -n "$files" ]
776 then
777 test -n "$cached" &&
465d6a00 778 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
779 diff_cmd=diff-files
780 head=
781 fi
782
28f9af5d 783 cd_to_toplevel
091a6eb0 784 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 785 # Get modified modules cared by user
18076502 786 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 787 sane_egrep '^:([0-7]* )?160000' |
cf9e55f4 788 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
789 do
790 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
791 if test "$status" = D || test "$status" = T
792 then
6a066230 793 printf '%s\n' "$sm_path"
496eeeb1
EP
794 continue
795 fi
927b26f8 796 # Respect the ignore setting for --for-status.
797 if test -n "$for_status"
798 then
0ea306ef 799 name=$(git submodule--helper name "$sm_path")
927b26f8 800 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 801 test $status != A && test $ignore_config = all && continue
927b26f8 802 fi
28f9af5d 803 # Also show added or modified modules which are checked out
974ce807 804 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 805 printf '%s\n' "$sm_path"
28f9af5d
PY
806 done
807 )
1cb639e6 808
d0f64dd4
PY
809 test -z "$modules" && return
810
18076502 811 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 812 sane_egrep '^:([0-7]* )?160000' |
1cb639e6 813 cut -c2- |
cf9e55f4 814 while read -r mod_src mod_dst sha1_src sha1_dst status name
1cb639e6
PY
815 do
816 if test -z "$cached" &&
817 test $sha1_dst = 0000000000000000000000000000000000000000
818 then
819 case "$mod_dst" in
820 160000)
821 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
822 ;;
823 100644 | 100755 | 120000)
824 sha1_dst=$(git hash-object $name)
825 ;;
826 000000)
827 ;; # removed
828 *)
829 # unexpected type
6ff875c5 830 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
831 continue ;;
832 esac
833 fi
834 missing_src=
835 missing_dst=
836
837 test $mod_src = 160000 &&
974ce807 838 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
839 missing_src=t
840
841 test $mod_dst = 160000 &&
974ce807 842 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 843 missing_dst=t
bffe71f4 844
44431df0 845 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
091a6eb0 846
1cb639e6
PY
847 total_commits=
848 case "$missing_src,$missing_dst" in
849 t,)
091a6eb0 850 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
851 ;;
852 ,t)
091a6eb0 853 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
854 ;;
855 t,t)
091a6eb0 856 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
857 ;;
858 *)
859 errmsg=
860 total_commits=$(
496eeeb1 861 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
862 then
863 range="$sha1_src...$sha1_dst"
864 elif test $mod_src = 160000
865 then
866 range=$sha1_src
867 else
868 range=$sha1_dst
869 fi
870 GIT_DIR="$name/.git" \
b0e621ad 871 git rev-list --first-parent $range -- | wc -l
1cb639e6 872 )
eed35595 873 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
874 ;;
875 esac
876
877 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
878 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
879 if test $status = T
880 then
b3e73449
ÆAB
881 blob="$(gettext "blob")"
882 submodule="$(gettext "submodule")"
1cb639e6
PY
883 if test $mod_dst = 160000
884 then
091a6eb0 885 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 886 else
091a6eb0 887 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
888 fi
889 else
091a6eb0 890 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
891 fi
892 if test -n "$errmsg"
893 then
894 # Don't give error msg for modification whose dst is not submodule
895 # i.e. deleted or changed to blob
896 test $mod_dst = 160000 && echo "$errmsg"
897 else
496eeeb1 898 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 899 then
f2dc06a3
PY
900 limit=
901 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 902 GIT_DIR="$name/.git" \
f2dc06a3 903 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
904 --first-parent $sha1_src...$sha1_dst
905 elif test $mod_dst = 160000
906 then
907 GIT_DIR="$name/.git" \
908 git log --pretty='format: > %s' -1 $sha1_dst
909 else
910 GIT_DIR="$name/.git" \
911 git log --pretty='format: < %s' -1 $sha1_src
912 fi
913 echo
914 fi
915 echo
3ba7407b 916 done
28f9af5d 917}
70c7ac22 918#
941987a5 919# List all submodules, prefixed with:
70c7ac22
LH
920# - submodule not initialized
921# + different revision checked out
922#
923# If --cached was specified the revision in the index will be printed
924# instead of the currently checked out revision.
925#
926# $@ = requested paths (default to all)
927#
23a485e3 928cmd_status()
70c7ac22 929{
5c08dbbd
JH
930 # parse $args after "submodule ... status".
931 while test $# -ne 0
932 do
933 case "$1" in
934 -q|--quiet)
2e6a30ef 935 GIT_QUIET=1
5c08dbbd
JH
936 ;;
937 --cached)
938 cached=1
939 ;;
64b19ffe
JH
940 --recursive)
941 recursive=1
942 ;;
5c08dbbd
JH
943 --)
944 shift
945 break
946 ;;
947 -*)
948 usage
949 ;;
950 *)
951 break
952 ;;
953 esac
954 shift
955 done
956
a9f8a375 957 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} "$@"
70c7ac22 958}
2327f61e
DA
959#
960# Sync remote urls for submodules
961# This makes the value for remote.$remote.url match the value
962# specified in .gitmodules.
963#
964cmd_sync()
965{
966 while test $# -ne 0
967 do
968 case "$1" in
969 -q|--quiet)
2e6a30ef 970 GIT_QUIET=1
2327f61e
DA
971 shift
972 ;;
82f49f29
PH
973 --recursive)
974 recursive=1
975 shift
976 ;;
2327f61e
DA
977 --)
978 shift
979 break
980 ;;
981 -*)
982 usage
983 ;;
984 *)
985 break
986 ;;
987 esac
988 done
e7849a96 989
13424764 990 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
2327f61e 991}
70c7ac22 992
f6f85861
SB
993cmd_absorbgitdirs()
994{
995 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
996}
997
5c08dbbd
JH
998# This loop parses the command line arguments to find the
999# subcommand name to dispatch. Parsing of the subcommand specific
1000# options are primarily done by the subcommand implementations.
1001# Subcommand specific options such as --branch and --cached are
1002# parsed here as well, for backward compatibility.
1003
1004while test $# != 0 && test -z "$command"
70c7ac22
LH
1005do
1006 case "$1" in
f6f85861 1007 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
5c08dbbd 1008 command=$1
70c7ac22
LH
1009 ;;
1010 -q|--quiet)
2e6a30ef 1011 GIT_QUIET=1
70c7ac22 1012 ;;
ecda0723
SV
1013 -b|--branch)
1014 case "$2" in
1015 '')
1016 usage
1017 ;;
1018 esac
1019 branch="$2"; shift
1020 ;;
70c7ac22 1021 --cached)
28f9af5d 1022 cached="$1"
70c7ac22
LH
1023 ;;
1024 --)
1025 break
1026 ;;
1027 -*)
1028 usage
1029 ;;
1030 *)
1031 break
1032 ;;
1033 esac
1034 shift
1035done
1036
5c08dbbd 1037# No command word defaults to "status"
af9c9f97
RR
1038if test -z "$command"
1039then
1040 if test $# = 0
1041 then
1042 command=status
1043 else
1044 usage
1045 fi
1046fi
5c08dbbd
JH
1047
1048# "-b branch" is accepted only by "add"
1049if test -n "$branch" && test "$command" != add
1050then
ecda0723 1051 usage
5c08dbbd
JH
1052fi
1053
28f9af5d 1054# "--cached" is accepted only by "status" and "summary"
496eeeb1 1055if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1056then
70c7ac22 1057 usage
5c08dbbd
JH
1058fi
1059
1060"cmd_$command" "$@"